package cn.com.infosec.mozilla;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERBitString;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.mozilla.PublicKeyAndChallenge;
import cn.com.infosec.asn1.x509.AlgorithmIdentifier;
import cn.com.infosec.asn1.x509.SubjectPublicKeyInfo;
import java.security.InvalidKeyException;
import java.security.KeyFactory;
import java.security.PublicKey;
import java.security.Signature;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.X509EncodedKeySpec;

public class SignedPublicKeyAndChallenge extends ASN1Encodable {
   private ASN1Sequence spkacSeq;
   private PublicKeyAndChallenge pkac;
   private AlgorithmIdentifier signatureAlgorithm;
   private DERBitString signature;

   private static ASN1Sequence toDERSequence(byte[] param0) {
      // $FF: Couldn't be decompiled
   }

   public SignedPublicKeyAndChallenge(byte[] bytes) {
      this.pkac = PublicKeyAndChallenge.getInstance((this.spkacSeq = toDERSequence(bytes)).getObjectAt(0));
      this.signatureAlgorithm = AlgorithmIdentifier.getInstance(this.spkacSeq.getObjectAt(1));
      this.signature = (DERBitString)this.spkacSeq.getObjectAt(2);
   }

   public DERObject toASN1Object() {
      return this.spkacSeq;
   }

   public PublicKeyAndChallenge getPublicKeyAndChallenge() {
      return this.pkac;
   }

   public boolean verify(String provider) {
      Signature var10000 = Signature.getInstance(this.signatureAlgorithm.getObjectId().getId(), provider);
      var10000.initVerify(this.getPublicKey(provider));
      var10000.update((new DERBitString(this.pkac)).getBytes());
      return var10000.verify(this.signature.getBytes());
   }

   public PublicKey getPublicKey(String provider) {
      SubjectPublicKeyInfo var6;
      SubjectPublicKeyInfo var10000 = var6 = this.pkac.getSubjectPublicKeyInfo();

      boolean var10001;
      DERBitString var8;
      try {
         var8 = new DERBitString;
      } catch (InvalidKeySpecException var5) {
         var10001 = false;
         throw new InvalidKeyException("error encoding public key");
      }

      DERBitString var2 = var8;

      X509EncodedKeySpec var9;
      try {
         var8.<init>(var6);
         var9 = new X509EncodedKeySpec;
      } catch (InvalidKeySpecException var4) {
         var10001 = false;
         throw new InvalidKeyException("error encoding public key");
      }

      X509EncodedKeySpec var7 = var9;

      try {
         var9.<init>(var2.getBytes());
         return KeyFactory.getInstance(var10000.getAlgorithmId().getObjectId().getId(), provider).generatePublic(var7);
      } catch (InvalidKeySpecException var3) {
         var10001 = false;
         throw new InvalidKeyException("error encoding public key");
      }
   }
}
